//
// $Id: TCOV.cc,v 1.1 2004/01/24 20:02:23 ejb Exp $
// $Source: /home/ejb/Q/pstt/CVSroot/test-coverage/example/search/TCOV.cc,v $
// $Author: ejb $
//
// This code comes without any warranty of any kind.  It is provided
// for the sole purpose of illustrating the test coverage system
// outlined in the accompanying paper.  No restrictions are placed on
// the use of this code.  Copyright (C) 2004 Jay Berkenbilt, Apex
// CoVantage.
//


#ifndef NO_RCS_HDRS
// Define a static function and call it.  No warnings this way.
static void rcsid(const char * const)
{rcsid("@(#)$Id: TCOV.cc,v 1.1 2004/01/24 20:02:23 ejb Exp $");}
#endif // ! NO_RCS_HDRS

#include "TCOV.hh"

#include <string>
#include <stdio.h>
#include <stdlib.h>
#ifdef _WIN32
#include <Windows.h>
#endif

static bool
get_env(std::string const& var, std::string* value)
{
    // This was basically ripped out of wxWindows.
#ifdef _WIN32
    // first get the size of the buffer
    DWORD len = ::GetEnvironmentVariable(var.c_str(), NULL, 0);
    if (len == 0)
    {
        // this means that there is no such variable
        return false;
    }

    if (value)
    {
	char* t = new char[len + 1];
        ::GetEnvironmentVariable(var.c_str(), t, len);
	*value = t;
	delete [] t;
    }

    return true;
#else
    char* p = getenv(var.c_str());
    if (p == 0)
    {
        return false;
    }
    if (value)
    {
        *value = p;
    }

    return true;
#endif
}

static bool tc_active(char const* const scope)
{
    std::string value;
    return (get_env("TC_SCOPE", &value) && (value == scope));
}

void TCOV::TC(char const* const scope, char const* const ccase, int n)
{
    if (! tc_active(scope))
    {
	return;
    }

    std::string filename;
#ifdef _WIN32
# define TC_ENV "TC_WIN_FILENAME"
#else
# define TC_ENV "TC_FILENAME"
#endif
    if (! get_env(TC_ENV, &filename))
    {
	return;
    }
#undef TC_ENV

    FILE* tc = fopen(filename.c_str(), "ab");
    if (tc)
    {
	fprintf(tc, "%s %d\n", ccase, n);
	fclose(tc);
    }
}
